const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const compliance_categories = sequelize.define(
    'compliance_categories',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

category_name: {
        type: DataTypes.TEXT,
      
      

      },

category_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"gst",


"tds",


"labor",


"licenses",


"secretarial",


"other"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  compliance_categories.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity











    db.compliance_categories.hasMany(db.compliance_templates, {
      as: 'compliance_templates_category',
      foreignKey: {
          name: 'categoryId',
      },
      constraints: false,
    });




















//end loop



    db.compliance_categories.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.compliance_categories.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.compliance_categories.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return compliance_categories;
};


